diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/dquot.c linux-2.4.25-rc2-vs1.26-q0.13/fs/dquot.c
--- linux-2.4.25-rc2-vs1.26/fs/dquot.c	2004-02-12 22:58:34.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/dquot.c	2004-02-13 00:53:54.000000000 +0100
@@ -68,6 +68,7 @@
 #include <linux/init.h>
 #include <linux/module.h>
 #include <linux/proc_fs.h>
+#include <linux/quotaops.h>
 
 #include <asm/uaccess.h>
 
@@ -150,7 +151,6 @@ static void put_quota_format(struct quot
 
 static LIST_HEAD(inuse_list);
 static LIST_HEAD(free_dquots);
-static struct list_head dquot_hash[NR_DQHASH];
 
 static void dqput(struct dquot *);
 static struct dquot *dqduplicate(struct dquot *);
@@ -175,31 +175,80 @@ static inline void put_dquot_dup_ref(str
 	dquot->dq_dup_ref--;
 }
 
-static inline int const hashfn(struct super_block *sb, unsigned int id, int type)
+	/* dqhash hash (meta) */
+
+static struct list_head dqhash_hash[NR_DQH_HASH];
+
+#define HASHSB(sb) ((unsigned int ) (sb))
+
+static inline int const dqh_hashfn(struct super_block *sb, unsigned int xid)
 {
-	return((HASHDEV(sb->s_dev) ^ id) * (MAXQUOTAS - type)) % NR_DQHASH;
+	return (HASHSB(sb) ^ xid) % NR_DQH_HASH;
 }
 
-static inline void insert_dquot_hash(struct dquot *dquot)
+static inline void insert_dqhash_hash(struct dqhash *hash)
 {
-	struct list_head *head = dquot_hash + hashfn(dquot->dq_sb, dquot->dq_id, dquot->dq_type);
+	unsigned int hashent = dqh_hashfn(hash->dqh_sb, hash->dqh_xid);
+	struct list_head *head = dqhash_hash + hashent;
+	
+	list_add(&hash->dqh_list, head);
+	list_add(&hash->dqh_sblist, &hash->dqh_sb->s_dqhs);
+}
+
+static inline void remove_dqhash_hash(struct dqhash *hash)
+{
+	list_del_init(&hash->dqh_list);
+	list_del_init(&hash->dqh_sblist);
+}
+
+static inline struct dqhash *find_dqhash(unsigned int hashent, struct super_block *sb, unsigned int xid)
+{
+	struct list_head *head;
+	struct dqhash *dqh;
+
+	for (head = dqhash_hash[hashent].next; head != dqhash_hash+hashent; head = head->next) {
+		dqh = list_entry(head, struct dqhash, dqh_list);
+		if (dqh->dqh_sb == sb && dqh->dqh_xid == xid)
+			return dqh;
+	}
+	return NULL;
+}
+
+/* Add a dquot to the head of the free list */
+
+	/* dquot hash functions */
+
+static inline int const hashfn(unsigned int id, int type)
+{
+	return ((id + 42) * (MAXQUOTAS - type)) % NR_DQHASH;
+}
+
+static inline void insert_dquot_hash(struct dqhash *hash, struct dquot *dquot)
+{
+	struct list_head *head = hash->dqh_hash + hashfn(dquot->dq_id, dquot->dq_type);
 	list_add(&dquot->dq_hash, head);
+	dquot->dq_dqh = dqhget(hash);
 }
 
 static inline void remove_dquot_hash(struct dquot *dquot)
 {
-	list_del(&dquot->dq_hash);
-	INIT_LIST_HEAD(&dquot->dq_hash);
+	struct dqhash *dqh = dquot->dq_dqh;
+
+	if (!dqh)
+		BUG();
+	list_del_init(&dquot->dq_hash);
+	dquot->dq_dqh = NULL;
+	dqhput(dqh);
 }
 
-static inline struct dquot *find_dquot(unsigned int hashent, struct super_block *sb, unsigned int id, int type)
+static inline struct dquot *find_dquot(struct dqhash *hash, unsigned int hashent, unsigned int id, int type)
 {
 	struct list_head *head;
 	struct dquot *dquot;
 
-	for (head = dquot_hash[hashent].next; head != dquot_hash+hashent; head = head->next) {
+	for (head = hash->dqh_hash[hashent].next; head != hash->dqh_hash+hashent; head = head->next) {
 		dquot = list_entry(head, struct dquot, dq_hash);
-		if (dquot->dq_sb == sb && dquot->dq_id == id && dquot->dq_type == type)
+		if (dquot->dq_id == id && dquot->dq_type == type)
 			return dquot;
 	}
 	return NODQUOT;
@@ -230,8 +279,7 @@ static inline void remove_free_dquot(str
 {
 	if (list_empty(&dquot->dq_free))
 		return;
-	list_del(&dquot->dq_free);
-	INIT_LIST_HEAD(&dquot->dq_free);
+	list_del_init(&dquot->dq_free);
 	dqstats.free_dquots--;
 }
 
@@ -317,7 +365,7 @@ repeat:
 static int read_dqblk(struct dquot *dquot)
 {
 	int ret;
-	struct quota_info *dqopt = sb_dqopt(dquot->dq_sb);
+	struct quota_info *dqopt = dqh_dqopt(dquot->dq_dqh);
 
 	lock_dquot(dquot);
 	down(&dqopt->dqio_sem);
@@ -330,7 +378,7 @@ static int read_dqblk(struct dquot *dquo
 static int commit_dqblk(struct dquot *dquot)
 {
 	int ret;
-	struct quota_info *dqopt = sb_dqopt(dquot->dq_sb);
+	struct quota_info *dqopt = dqh_dqopt(dquot->dq_dqh);
 
 	down(&dqopt->dqio_sem);
 	ret = dqopt->ops[dquot->dq_type]->commit_dqblk(dquot);
@@ -341,50 +389,126 @@ static int commit_dqblk(struct dquot *dq
 /* Invalidate all dquots on the list, wait for all users. Note that this function is called
  * after quota is disabled so no new quota might be created. As we only insert to the end of
  * inuse list, we don't have to restart searching... */
-static void invalidate_dquots(struct super_block *sb, int type)
+static void invalidate_dquots(struct dqhash *hash, int type)
 {
-	struct dquot *dquot;
-	struct list_head *head;
+	int i, temp;
 
-restart:
-	list_for_each(head, &inuse_list) {
-		dquot = list_entry(head, struct dquot, dq_inuse);
-		if (dquot->dq_sb != sb)
-			continue;
-		if (dquot->dq_type != type)
-			continue;
-		dquot->dq_flags |= DQ_INVAL;
-		if (dquot->dq_count)
-			/*
-			 *  Wait for any users of quota. As we have already cleared the flags in
-			 *  superblock and cleared all pointers from inodes we are assured
-			 *  that there will be no new users of this quota.
-			 */
-			__wait_dquot_unused(dquot);
-		/* Quota now have no users and it has been written on last dqput() */
-		remove_dquot_hash(dquot);
-		remove_free_dquot(dquot);
-		remove_inuse(dquot);
-		kmem_cache_free(dquot_cachep, dquot);
-		goto restart;
+	for (i=0; i<NR_DQHASH; i++) {
+		struct list_head *head = &hash->dqh_hash[i];
+
+		while ((head = head->next) != &hash->dqh_hash[i]) {
+			struct dquot *dquot = list_entry(head, struct dquot, dq_hash);
+
+			if (dquot->dq_type != type)
+				continue;
+
+			temp = dquot->dq_flags;
+			dquot->dq_flags |= DQ_INVAL;
+			if (dquot->dq_count) {
+				printk("··· quota in use: %p (%d)\n", dquot, dquot->dq_count);
+				printk("··· dquot (%d,%d,%d) dqh: %p (%d)\n",
+					dquot->dq_id, dquot->dq_type, temp,
+					dquot->dq_dqh, (dquot->dq_dqh?dquot->dq_dqh->dqh_xid:-1));
+				/*
+				 *  Wait for any users of quota. As we have already cleared the flags in
+				 *  superblock and cleared all pointers from inodes we are assured
+				 *  that there will be no new users of this quota.
+				 */
+				__wait_dquot_unused(dquot);
+			}
+				
+			remove_dquot_hash(dquot);
+			remove_free_dquot(dquot);
+			remove_inuse(dquot);
+			kmem_cache_free(dquot_cachep, dquot);
+			/* now restart */
+			head = &hash->dqh_hash[i];
+		}
 	}
 }
 
-static int vfs_quota_sync(struct super_block *sb, int type)
+/* Dquota Hash Management Functions */
+
+static unsigned int dqhash_id = 0;
+
+struct dqhash *new_dqhash(struct super_block *sb, unsigned int xid)
+{
+	struct dqhash *hash;
+	int i;
+	
+	hash = kmalloc(sizeof(struct dqhash),  GFP_USER);
+	if (!hash)
+		return ERR_PTR(-ENOMEM);
+
+	memset(hash, 0, sizeof(struct dqhash));
+	hash->dqh_id = dqhash_id++;
+	hash->dqh_xid = xid;
+	atomic_set(&hash->dqh_count, 1);
+	INIT_LIST_HEAD(&hash->dqh_list);
+	INIT_LIST_HEAD(&hash->dqh_sblist);
+	for (i = 0; i < NR_DQHASH; i++)
+		INIT_LIST_HEAD(hash->dqh_hash + i);
+	sema_init(&hash->dqh_dqopt.dqio_sem, 1);
+	sema_init(&hash->dqh_dqopt.dqoff_sem, 1);
+	hash->dqh_qop = sb->s_qop;
+	hash->dqh_qcop = sb->s_qcop;
+	hash->dqh_sb = sb;
+
+	hash->dqh_dlimit.dl_ilimit = NOILIMIT;
+	hash->dqh_dlimit.dl_blimit = NOBLIMIT;
+	hash->dqh_dlimit.dl_l2bsize = sb->s_blocksize_bits;
+	hash->dqh_dlimit.dl_nrlmult = (1 << 10) * 90 / 100;
+	init_rwsem(&hash->dqh_dlimit.dl_sem);
+
+	lock_kernel();
+	dprintk("··· new_dqhash: *%p[%d,#%d] sb:%p\n",
+		hash, hash->dqh_id, hash->dqh_xid, hash->dqh_sb);
+	insert_dqhash_hash(hash);
+	unlock_kernel();
+	return hash;
+}
+
+void destroy_dqhash(struct dqhash *hash)
+{
+	int cnt;
+
+	dprintk("··· destroy_dqhash: *%p[%d,#%d] sb:%p\n",
+		hash, hash->dqh_id, hash->dqh_xid, hash->dqh_sb);
+	lock_kernel();
+	remove_dqhash_hash(hash);
+	unlock_kernel();
+	for (cnt = 0; cnt < MAXQUOTAS; cnt++)	/* should not be required anymore! */
+		invalidate_dquots(hash, cnt);
+	hash->dqh_xid = -1;
+	kfree(hash);
+}
+
+struct dqhash *get_dqhash(struct super_block *sb, unsigned int xid)
+{
+	unsigned int hashent = dqh_hashfn(sb, xid);
+	struct dqhash *hash;
+
+	if ((hash = find_dqhash(hashent, sb, xid)))
+		return dqhget(hash);
+	return NULL;
+}
+
+
+static int vfs_quota_sync(struct dqhash *hash, int type)
 {
 	struct list_head *head;
 	struct dquot *dquot;
-	struct quota_info *dqopt = sb_dqopt(sb);
+	struct quota_info *dqopt = dqh_dqopt(hash);
 	int cnt;
 
 restart:
 	list_for_each(head, &inuse_list) {
 		dquot = list_entry(head, struct dquot, dq_inuse);
-		if (sb && dquot->dq_sb != sb)
+		if (hash && dquot->dq_dqh != hash)
 			continue;
                 if (type != -1 && dquot->dq_type != type)
 			continue;
-		if (!dquot->dq_sb)	/* Invalidated? */
+		if (!dquot->dq_dqh)	/* Invalidated? */
 			continue;
 		if (!dquot_dirty(dquot) && !(dquot->dq_flags & DQ_LOCKED))
 			continue;
@@ -396,16 +520,16 @@ restart:
 		if (dquot->dq_flags & DQ_LOCKED)
 			wait_on_dquot(dquot);
 		if (dquot_dirty(dquot))
-			sb->dq_op->write_dquot(dquot);
+			hash->dqh_qop->write_dquot(dquot);
 		dqput(dquot);
 		goto restart;
 	}
 	for (cnt = 0; cnt < MAXQUOTAS; cnt++)
-		if ((cnt == type || type == -1) && sb_has_quota_enabled(sb, cnt))
+		if ((cnt == type || type == -1) && dqh_has_quota_enabled(hash, cnt))
 			dqopt->info[cnt].dqi_flags &= ~DQF_ANY_DQUOT_DIRTY;
 	for (cnt = 0; cnt < MAXQUOTAS; cnt++)
-		if ((cnt == type || type == -1) && sb_has_quota_enabled(sb, cnt) && info_dirty(&dqopt->info[cnt]))
-			dqopt->ops[cnt]->write_file_info(sb, cnt);
+		if ((cnt == type || type == -1) && dqh_has_quota_enabled(hash, cnt) && info_dirty(&dqopt->info[cnt]))
+			dqopt->ops[cnt]->write_file_info(hash, cnt);
 	dqstats.syncs++;
 
 	return 0;
@@ -420,11 +544,19 @@ restart:
 	spin_lock(&sb_lock);
 	list_for_each(head, &super_blocks) {
 		struct super_block *sb = list_entry(head, struct super_block, s_list);
+		struct list_head *qhead;
 
-		for (cnt = 0, dirty = 0; cnt < MAXQUOTAS; cnt++)
-			if ((type == cnt || type == -1) && sb_has_quota_enabled(sb, cnt)
-			    && sb_dqopt(sb)->info[cnt].dqi_flags & DQF_ANY_DQUOT_DIRTY)
-				dirty = 1;
+		dirty = 0;
+		list_for_each(qhead, &sb->s_dqhs) {
+			struct dqhash *dqh = list_entry(qhead, struct dqhash, dqh_sblist);
+
+			for (cnt = 0; cnt < MAXQUOTAS; cnt++)
+				if ((type == cnt || type == -1) && dqh_has_quota_enabled(dqh, cnt)
+				&& dqh_dqopt(dqh)->info[cnt].dqi_flags & DQF_ANY_DQUOT_DIRTY)
+					dirty = 1;
+			if (dirty)
+				break;
+		}
 		if (!dirty)
 			continue;
 		sb->s_count++;
@@ -440,35 +572,44 @@ restart:
 	return NULL;
 }
 
+void sync_dquots_sb(struct super_block *sb, int type)
+{
+	struct list_head *head;
+	
+	lock_kernel();
+	list_for_each(head, &sb->s_dqhs) {
+		struct dqhash *dqh = list_entry(head, struct dqhash, dqh_sblist);
+
+		if (dqh->dqh_qcop->quota_sync)
+			dqh->dqh_qcop->quota_sync(dqh, type);
+	}
+	unlock_kernel();
+}
+
+
 void sync_dquots_dev(kdev_t dev, int type)
 {
 	struct super_block *sb;
 
 	if (dev) {
 		if ((sb = get_super(dev))) {
-			lock_kernel();
-			if (sb->s_qcop->quota_sync)
-				sb->s_qcop->quota_sync(sb, type);
-			unlock_kernel();
+			sync_dquots_sb(sb, type);
 			drop_super(sb);
 		}
 	}
 	else {
 		while ((sb = get_super_to_sync(type))) {
-			lock_kernel();
-			if (sb->s_qcop->quota_sync)
-				sb->s_qcop->quota_sync(sb, type);
-			unlock_kernel();
+			sync_dquots_sb(sb, type);
 			drop_super(sb);
 		}
 	}
 }
 
-void sync_dquots_sb(struct super_block *sb, int type)
+void sync_dquots_dqh(struct dqhash *hash, int type)
 {
 	lock_kernel();
-	if (sb->s_qcop->quota_sync)
-		sb->s_qcop->quota_sync(sb, type);
+	if (dqhash_valid(hash) && hash->dqh_qcop->quota_sync)
+		hash->dqh_qcop->quota_sync(hash, type);
 	unlock_kernel();
 }
 
@@ -543,7 +684,7 @@ we_slept:
 		return;
 	}
 	if (dquot_dirty(dquot)) {
-		dquot->dq_sb->dq_op->write_dquot(dquot);
+		dquot->dq_dqh->dqh_qop->write_dquot(dquot);
 		goto we_slept;
 	}
 
@@ -560,7 +701,7 @@ we_slept:
 	wake_up(&dquot->dq_wait_free);
 }
 
-static struct dquot *get_empty_dquot(struct super_block *sb, int type)
+static struct dquot *get_empty_dquot(kdev_t dev, int type)
 {
 	struct dquot *dquot;
 
@@ -574,8 +715,8 @@ static struct dquot *get_empty_dquot(str
 	INIT_LIST_HEAD(&dquot->dq_free);
 	INIT_LIST_HEAD(&dquot->dq_inuse);
 	INIT_LIST_HEAD(&dquot->dq_hash);
-	dquot->dq_sb = sb;
-	dquot->dq_dev = sb->s_dev;
+	dquot->dq_dqh = NULL;
+	dquot->dq_dev = dev;
 	dquot->dq_type = type;
 	dquot->dq_count = 1;
 	/* all dquots go on the inuse_list */
@@ -584,11 +725,11 @@ static struct dquot *get_empty_dquot(str
 	return dquot;
 }
 
-static struct dquot *dqget(struct super_block *sb, unsigned int id, int type)
+static struct dquot *dqget(struct dqhash *hash, unsigned int id, int type)
 {
-	unsigned int hashent = hashfn(sb, id, type);
+	unsigned int hashent = hashfn(id, type);
 	struct dquot *dquot, *empty = NODQUOT;
-	struct quota_info *dqopt = sb_dqopt(sb);
+	struct quota_info *dqopt = dqh_dqopt(hash);
 
 we_slept:
         if (!is_enabled(dqopt, type)) {
@@ -597,16 +738,17 @@ we_slept:
                 return NODQUOT;
 	}
 
-	if ((dquot = find_dquot(hashent, sb, id, type)) == NODQUOT) {
+	if ((dquot = find_dquot(hash, hashent, id, type)) == NODQUOT) {
 		if (empty == NODQUOT) {
-			if ((empty = get_empty_dquot(sb, type)) == NODQUOT)
+			kdev_t dev = hash->dqh_sb->s_dev;
+			if ((empty = get_empty_dquot(dev, type)) == NODQUOT)
 				schedule();	/* Try to wait for a moment... */
 			goto we_slept;
 		}
 		dquot = empty;
 		dquot->dq_id = id;
 		/* hash it first so it can be found */
-		insert_dquot_hash(dquot);
+		insert_dquot_hash(hash, dquot);
 		read_dqblk(dquot);
 	} else {
 		if (!dquot->dq_count)
@@ -618,7 +760,7 @@ we_slept:
 			dqput(empty);
 	}
 
-	if (!dquot->dq_sb) {	/* Has somebody invalidated entry under us? */
+	if (!dquot->dq_dqh) {	/* Has somebody invalidated entry under us? */
 		printk(KERN_ERR "VFS: dqget(): Quota invalidated in dqget()!\n");
 		dqput(dquot);
 		return NODQUOT;
@@ -634,7 +776,7 @@ static struct dquot *dqduplicate(struct 
 	if (dquot == NODQUOT)
 		return NODQUOT;
 	get_dquot_ref(dquot);
-	if (!dquot->dq_sb) {
+	if (!dquot->dq_dqh) {
 		printk(KERN_ERR "VFS: dqduplicate(): Invalidated quota to be duplicated!\n");
 		put_dquot_ref(dquot);
 		return NODQUOT;
@@ -675,20 +817,32 @@ static int dqinit_needed(struct inode *i
 	return 0;
 }
 
-static void add_dquot_ref(struct super_block *sb, int type)
+static void add_dquot_ref(struct dqhash *hash, int type)
 {
 	struct list_head *p;
+	struct super_block *sb = hash->dqh_sb;
 
 restart:
 	file_list_lock();
 	list_for_each(p, &sb->s_files) {
 		struct file *filp = list_entry(p, struct file, f_list);
 		struct inode *inode = filp->f_dentry->d_inode;
-		if (filp->f_mode & FMODE_WRITE && dqinit_needed(inode, type)) {
+
+		CHECK_DQHASH(inode);
+		if (filp->f_mode & FMODE_WRITE
+			&& hash->dqh_xid == inode->i_xid
+			&& dqinit_needed(inode, type)) {
 			struct vfsmount *mnt = mntget(filp->f_vfsmnt);
 			struct dentry *dentry = dget(filp->f_dentry);
+
+			/* an open file might have an xid but no hash yet */
+			if (inode->i_dqh && hash != inode->i_dqh)
+				printk("··· BAD INODE: add_dquot_ref(%p[%d], %d) %p[%d](%p) »%*s«\n",
+					hash, hash->dqh_xid, type, inode, inode->i_xid, inode->i_dqh,
+					filp->f_dentry->d_name.len, filp->f_dentry->d_name.name);
+
 			file_list_unlock();
-			sb->dq_op->initialize(inode, type);
+			hash->dqh_qop->initialize(inode, type);
 			dput(dentry);
 			mntput(mnt);
 			/* As we may have blocked we had better restart... */
@@ -696,6 +850,7 @@ restart:
 		}
 	}
 	file_list_unlock();
+	dqhget(hash);
 }
 
 /* Return 0 if dqput() won't block (note that 1 doesn't necessarily mean blocking) */
@@ -747,8 +902,7 @@ void put_dquot_list(struct list_head *to
 	while (act_head != tofree_head) {
 		dquot = list_entry(act_head, struct dquot, dq_free);
 		act_head = act_head->next;
-		list_del(&dquot->dq_free);	/* Remove dquot from the list so we won't have problems... */
-		INIT_LIST_HEAD(&dquot->dq_free);
+		list_del_init(&dquot->dq_free);	/* Remove from list to avoid problems... */
 		dqput(dquot);
 	}
 	unlock_kernel();
@@ -820,7 +974,7 @@ static void print_warning(struct dquot *
 	if (!need_print_warning(dquot, flag))
 		return;
 	dquot->dq_flags |= flag;
-	tty_write_message(current->tty, (char *)bdevname(dquot->dq_sb->s_dev));
+	tty_write_message(current->tty, (char *)bdevname(dquot->dq_dqh->dqh_sb->s_dev));
 	if (warntype == ISOFTWARN || warntype == BSOFTWARN)
 		tty_write_message(current->tty, ": warning, ");
 	else
@@ -860,7 +1014,7 @@ static inline void flush_warnings(struct
 
 static inline char ignore_hardlimit(struct dquot *dquot)
 {
-	struct mem_dqinfo *info = &sb_dqopt(dquot->dq_sb)->info[dquot->dq_type];
+	struct mem_dqinfo *info = &dqh_dqopt(dquot->dq_dqh)->info[dquot->dq_type];
 
 	return capable(CAP_SYS_RESOURCE) &&
 	    (info->dqi_format->qf_fmt_id != QFMT_VFS_OLD || !(info->dqi_flags & V1_DQF_RSQUASH));
@@ -891,7 +1045,7 @@ static int check_idq(struct dquot *dquot
 	   (dquot->dq_dqb.dqb_curinodes + inodes) > dquot->dq_dqb.dqb_isoftlimit &&
 	    dquot->dq_dqb.dqb_itime == 0) {
 		*warntype = ISOFTWARN;
-		dquot->dq_dqb.dqb_itime = CURRENT_TIME + sb_dqopt(dquot->dq_sb)->info[dquot->dq_type].dqi_igrace;
+		dquot->dq_dqb.dqb_itime = CURRENT_TIME + dqh_dqopt(dquot->dq_dqh)->info[dquot->dq_type].dqi_igrace;
 	}
 
 	return QUOTA_OK;
@@ -925,7 +1079,7 @@ static int check_bdq(struct dquot *dquot
 	    dquot->dq_dqb.dqb_btime == 0) {
 		if (!prealloc) {
 			*warntype = BSOFTWARN;
-			dquot->dq_dqb.dqb_btime = CURRENT_TIME + sb_dqopt(dquot->dq_sb)->info[dquot->dq_type].dqi_bgrace;
+			dquot->dq_dqb.dqb_btime = CURRENT_TIME + dqh_dqopt(dquot->dq_dqh)->info[dquot->dq_type].dqi_bgrace;
 		}
 		else
 			/*
@@ -946,17 +1100,30 @@ static int check_bdq(struct dquot *dquot
 void dquot_initialize(struct inode *inode, int type)
 {
 	struct dquot *dquot[MAXQUOTAS];
+	struct dqhash *dqh = NULL;
 	unsigned int id = 0;
 	int cnt;
 
+	dprintk("··· dquot_initialize(A): \t" DFM_INO ": " DFM_DQH ", " DFM_DQH "\n",
+		DBD_INO(inode), DBD_DQH(inode->i_dqh), DBD_DQH(dqh));
 	if (IS_NOQUOTA(inode))
 		return;
+
+	dqh = get_dqhash(inode->i_sb, current->vx_id);
+	dprintk("··· dquot_initialize: \t" DFM_INO ": " DFM_DQH ", " DFM_DQH "\n",
+		DBD_INO(inode), DBD_DQH(inode->i_dqh), DBD_DQH(dqh));
+	if (dqh && !inode->i_dqh) {
+		dprintk("··· MISSING DQH: \t" DFM_INO " add " DFM_DQH "\n",
+			DBD_INO(inode), DBD_DQH(dqh));
+		inode->i_dqh = dqh;
+	}
+
 	/* Build list of quotas to initialize... We can block here */
 	for (cnt = 0; cnt < MAXQUOTAS; cnt++) {
 		dquot[cnt] = NODQUOT;
 		if (type != -1 && cnt != type)
 			continue;
-		if (!sb_has_quota_enabled(inode->i_sb, cnt))
+		if (!dqh_has_quota_enabled(dqh, cnt))
 			continue;
 		if (inode->i_dquot[cnt] == NODQUOT) {
 			switch (cnt) {
@@ -967,13 +1134,17 @@ void dquot_initialize(struct inode *inod
 					id = inode->i_gid;
 					break;
 			}
-			dquot[cnt] = dqget(inode->i_sb, id, cnt);
+			dquot[cnt] = dqget(dqh, id, cnt);
 		}
 	}
+	dqhput(dqh);
+
 	/* NOBLOCK START: Here we shouldn't block */
 	for (cnt = 0; cnt < MAXQUOTAS; cnt++) {
-		if (dquot[cnt] == NODQUOT || !sb_has_quota_enabled(inode->i_sb, cnt) || inode->i_dquot[cnt] != NODQUOT)
+		if (dquot[cnt] == NODQUOT || !dqh_has_quota_enabled(dqh, cnt) || inode->i_dquot[cnt] != NODQUOT)
 			continue;
+		dprintk("··+ initialize: \t" DFM_INO ": " DFM_DQH " (%d)\n",
+			DBD_INO(inode), DBD_DQH(inode->i_dqh), cnt);
 		inode->i_dquot[cnt] = dquot[cnt];
 		dquot[cnt] = NODQUOT;
 		inode->i_flags |= S_QUOTA;
@@ -1057,7 +1228,7 @@ int dquot_alloc_inode(const struct inode
 	}
 	/* NOBLOCK Start */
 	for (cnt = 0; cnt < MAXQUOTAS; cnt++) {
-		dquot[cnt] = dqduplicate(inode -> i_dquot[cnt]);
+		dquot[cnt] = dqduplicate(inode->i_dquot[cnt]);
 		if (dquot[cnt] == NODQUOT)
 			continue;
 		if (check_idq(dquot[cnt], number, warntype+cnt) == NO_QUOTA)
@@ -1120,18 +1291,28 @@ void dquot_free_inode(const struct inode
 
 /*
  * Transfer the number of inode and blocks from one diskquota to an other.
- *
+ * If requested this, is also done from one quota hash to another.
  * This operation can block, but only after everything is updated
  */
-int dquot_transfer(struct inode *inode, struct iattr *iattr)
+int __dquot_transfer(struct inode *inode, struct iattr *iattr, struct dqhash *hash)
 {
 	qsize_t space;
 	struct dquot *transfer_from[MAXQUOTAS];
 	struct dquot *transfer_to[MAXQUOTAS];
-	int cnt, ret = NO_QUOTA, chuid = (iattr->ia_valid & ATTR_UID) && inode->i_uid != iattr->ia_uid,
-	    chgid = (iattr->ia_valid & ATTR_GID) && inode->i_gid != iattr->ia_gid;
+	struct dqhash *dqh = inode->i_dqh; /* use find_xid_dqhash(inode->i_sb) */
+	uid_t new_uid = (iattr->ia_valid & ATTR_UID) ? iattr->ia_uid : inode->i_uid;
+	gid_t new_gid = (iattr->ia_valid & ATTR_GID) ? iattr->ia_gid : inode->i_gid;
+	int cnt, chuid, chgid;
 	char warntype[MAXQUOTAS];
 
+	if (hash == dqh) {
+		chuid = (iattr->ia_valid & ATTR_UID) && inode->i_uid != iattr->ia_uid;
+		chgid = (iattr->ia_valid & ATTR_GID) && inode->i_gid != iattr->ia_gid;
+	}
+	/* transfer between quota hashes */
+	else
+		chuid = chgid = 1;
+
 	/* Clear the arrays */
 	for (cnt = 0; cnt < MAXQUOTAS; cnt++) {
 		transfer_to[cnt] = transfer_from[cnt] = NODQUOT;
@@ -1139,30 +1320,34 @@ int dquot_transfer(struct inode *inode, 
 	}
 	/* First build the transfer_to list - here we can block on reading of dquots... */
 	for (cnt = 0; cnt < MAXQUOTAS; cnt++) {
-		if (!sb_has_quota_enabled(inode->i_sb, cnt))
+		if (!dqh_has_quota_enabled(hash, cnt))
 			continue;
 		switch (cnt) {
 			case USRQUOTA:
 				if (!chuid)
 					continue;
-				transfer_to[cnt] = dqget(inode->i_sb, iattr->ia_uid, cnt);
+				transfer_to[cnt] = dqget(hash, new_uid, cnt);
+				dprintk("··+ usr transfer to: \t" DFM_DQH " (%d,%d) = $%p\n",
+					DBD_DQH(hash), new_uid, cnt, transfer_to[cnt]);
 				break;
 			case GRPQUOTA:
 				if (!chgid)
 					continue;
-				transfer_to[cnt] = dqget(inode->i_sb, iattr->ia_gid, cnt);
+				transfer_to[cnt] = dqget(hash, new_gid, cnt);
+				dprintk("··+ grp transfer to: \t" DFM_DQH " (%d,%d) = $%p\n",
+					DBD_DQH(hash), new_uid, cnt, transfer_to[cnt]);
 				break;
 		}
 	}
+
 	/* NOBLOCK START: From now on we shouldn't block */
 	space = inode_get_bytes(inode);
 	/* Build the transfer_from list and check the limits */
 	for (cnt = 0; cnt < MAXQUOTAS; cnt++) {
-		/* The second test can fail when quotaoff is in progress... */
-		if (transfer_to[cnt] == NODQUOT || !sb_has_quota_enabled(inode->i_sb, cnt))
-			continue;
-		transfer_from[cnt] = dqduplicate(inode->i_dquot[cnt]);
-		if (transfer_from[cnt] == NODQUOT)	/* Can happen on quotafiles (quota isn't initialized on them)... */
+		if (dqh_has_quota_enabled(dqh, cnt))
+			transfer_from[cnt] = dqduplicate(inode->i_dquot[cnt]);
+		if (transfer_to[cnt] == NODQUOT || !dqh_has_quota_enabled(hash, cnt))
+			/* transfer to noquota domain ... */
 			continue;
 		if (check_idq(transfer_to[cnt], 1, warntype+cnt) == NO_QUOTA ||
 		    check_bdq(transfer_to[cnt], space, 0, warntype+cnt) == NO_QUOTA)
@@ -1172,30 +1357,38 @@ int dquot_transfer(struct inode *inode, 
 	/*
 	 * Finally perform the needed transfer from transfer_from to transfer_to
 	 */
+	inode->i_flags &= ~S_QUOTA;
 	for (cnt = 0; cnt < MAXQUOTAS; cnt++) {
-		/*
-		 * Skip changes for same uid or gid or for non-existing quota-type.
-		 */
-		if (transfer_from[cnt] == NODQUOT || transfer_to[cnt] == NODQUOT)
+		if (transfer_from[cnt] == NODQUOT && transfer_to[cnt] == NODQUOT)
+			/* nothing to transfer ... */
 			continue;
 
-		dquot_decr_inodes(transfer_from[cnt], 1);
-		dquot_decr_space(transfer_from[cnt], space);
-
-		dquot_incr_inodes(transfer_to[cnt], 1);
-		dquot_incr_space(transfer_to[cnt], space);
-
-		if (inode->i_dquot[cnt] == NODQUOT)
-			BUG();
+		if (transfer_from[cnt] != NODQUOT) {
+			dprintk("··+ decrement: $%p\n", transfer_from[cnt]);
+			dquot_decr_inodes(transfer_from[cnt], 1);
+			dquot_decr_space(transfer_from[cnt], space);
+		}
+		if (transfer_to[cnt] != NODQUOT) {
+			dprintk("··+ increment: $%p\n", transfer_to[cnt]);
+			dquot_incr_inodes(transfer_to[cnt], 1);
+			dquot_incr_space(transfer_to[cnt], space);
+			inode->i_flags |= S_QUOTA;
+		}
 		inode->i_dquot[cnt] = transfer_to[cnt];
-		/*
-		 * We've got to release transfer_from[] twice - once for dquot_transfer() and
-		 * once for inode. We don't want to release transfer_to[] as it's now placed in inode
-		 */
-		transfer_to[cnt] = transfer_from[cnt];
 	}
+	
 	/* NOBLOCK END. From now on we can block as we wish */
-	ret = QUOTA_OK;
+
+	for (cnt = 0; cnt < MAXQUOTAS; cnt++) {
+		/* First we must put duplicate - otherwise we might deadlock */
+		if (transfer_from[cnt] != NODQUOT) {
+			dqputduplicate(transfer_from[cnt]);
+			/* release for inode */
+			dqput(transfer_from[cnt]);
+		}
+	}
+	return QUOTA_OK;
+
 warn_put_all:
 	flush_warnings(transfer_to, warntype);
 	for (cnt = 0; cnt < MAXQUOTAS; cnt++) {
@@ -1205,9 +1398,58 @@ warn_put_all:
 		if (transfer_to[cnt] != NODQUOT)
 			dqput(transfer_to[cnt]);
 	}
+	return NO_QUOTA;
+}
+
+int dquot_transfer(struct inode *inode, struct iattr *iattr)
+{
+	return __dquot_transfer(inode, iattr, inode->i_dqh);
+}
+
+int dqhash_transfer(struct inode *inode, struct dqhash *hash)
+{
+	struct iattr iattr;
+	int ret = 0;
+	
+	dprintk("··· dqhash_transfer(A): \t" DFM_INO ": " DFM_DQH " -> " DFM_DQH "\n",
+		DBD_INO(inode), DBD_DQH(inode->i_dqh), DBD_DQH(hash));
+	if (hash == inode->i_dqh)
+		return ret;
+	dprintk("··· dqhash_transfer(B): \t" DFM_INO ": " DFM_DQH " -> " DFM_DQH "\n",
+		DBD_INO(inode), DBD_DQH(inode->i_dqh), DBD_DQH(hash));
+	if (IS_NOQUOTA(inode) || (!IS_QUOTAINIT(inode) && inode->i_dqh))
+		return ret;
+	dprintk("··· dqhash_transfer: \t" DFM_INO ": " DFM_DQH " -> " DFM_DQH "\n",
+		DBD_INO(inode), DBD_DQH(inode->i_dqh), DBD_DQH(hash));
+	iattr.ia_valid = 0;
+	ret = __dquot_transfer(inode, &iattr, hash);
+	return ret;
+}
+
+int dlimit_transfer(struct inode *inode, struct dqhash *hash)
+{
+	qsize_t space;
+	int ret = 0;
+
+	if (hash == inode->i_dqh)
+		return ret;
+
+	space = inode_get_bytes(inode);
+
+	/* check for available space, and then? */
+	
+	if (dqhash_valid(inode->i_dqh)) {
+		dlimit_decr_inodes(inode->i_dqh, 1);
+		dlimit_decr_space(inode->i_dqh, space);
+	}
+	if (dqhash_valid(hash)) {
+		dlimit_incr_inodes(hash, 1);
+		dlimit_incr_space(hash, space);
+	}
 	return ret;
 }
 
+
 /*
  * Definitions of diskquota operations.
  */
@@ -1253,19 +1495,17 @@ static inline void reset_enable_flags(st
 }
 
 /* Function in inode.c - remove pointers to dquots in icache */
-extern void remove_dquot_ref(struct super_block *, int);
+extern void remove_dquot_ref(struct dqhash *, int);
 
 /*
- * Turn quota off on a device. type == -1 ==> quotaoff for all types (umount)
+ * Turn quota off on a hash. type == -1 ==> quotaoff for all types (umount)
  */
-int vfs_quota_off(struct super_block *sb, int type)
+int vfs_quota_off(struct dqhash *hash, int type)
 {
 	int cnt;
-	struct quota_info *dqopt = sb_dqopt(sb);
+	struct quota_info *dqopt = dqh_dqopt(hash);
 
 	lock_kernel();
-	if (!sb)
-		goto out;
 
 	/* We need to serialize quota_off() for device */
 	down(&dqopt->dqoff_sem);
@@ -1277,12 +1517,12 @@ int vfs_quota_off(struct super_block *sb
 		reset_enable_flags(dqopt, cnt);
 
 		/* Note: these are blocking operations */
-		remove_dquot_ref(sb, cnt);
-		invalidate_dquots(sb, cnt);
+		remove_dquot_ref(hash, cnt);
+		invalidate_dquots(hash, cnt);
 		if (info_dirty(&dqopt->info[cnt]))
-			dqopt->ops[cnt]->write_file_info(sb, cnt);
+			dqopt->ops[cnt]->write_file_info(hash, cnt);
 		if (dqopt->ops[cnt]->free_file_info)
-			dqopt->ops[cnt]->free_file_info(sb, cnt);
+			dqopt->ops[cnt]->free_file_info(hash, cnt);
 		put_quota_format(dqopt->info[cnt].dqi_format);
 
 		fput(dqopt->files[cnt]);
@@ -1293,16 +1533,15 @@ int vfs_quota_off(struct super_block *sb
 		dqopt->ops[cnt] = NULL;
 	}
 	up(&dqopt->dqoff_sem);
-out:
 	unlock_kernel();
 	return 0;
 }
 
-int vfs_quota_on(struct super_block *sb, int type, int format_id, char *path)
+int vfs_quota_on(struct dqhash *hash, int type, int format_id, char *path)
 {
 	struct file *f = NULL;
 	struct inode *inode;
-	struct quota_info *dqopt = sb_dqopt(sb);
+	struct quota_info *dqopt = dqh_dqopt(hash);
 	struct quota_format_type *fmt = find_quota_format(format_id);
 	int error;
 
@@ -1314,9 +1553,11 @@ int vfs_quota_on(struct super_block *sb,
 	}
 
 	down(&dqopt->dqoff_sem);
+	dprintk("··· vfs_quota_on: %p, type=%d, format=%d, path=%s\n", hash, type, format_id, path);
 
 	f = filp_open(path, O_RDWR, 0600);
 
+	dprintk("··· vfs_quota_on: file=%p\n", f);
 	error = PTR_ERR(f);
 	if (IS_ERR(f))
 		goto out_lock;
@@ -1329,7 +1570,7 @@ int vfs_quota_on(struct super_block *sb,
 	if (!S_ISREG(inode->i_mode))
 		goto out_f;
 	error = -EINVAL;
-	if (!fmt->qf_ops->check_quota_file(sb, type))
+	if (!fmt->qf_ops->check_quota_file(hash, type))
 		goto out_f;
 	/* We don't want quota and atime on quota files */
 	dquot_drop(inode);
@@ -1337,11 +1578,11 @@ int vfs_quota_on(struct super_block *sb,
 
 	dqopt->ops[type] = fmt->qf_ops;
 	dqopt->info[type].dqi_format = fmt;
-	if ((error = dqopt->ops[type]->read_file_info(sb, type)) < 0)
+	if ((error = dqopt->ops[type]->read_file_info(hash, type)) < 0)
 		goto out_f;
 	set_enable_flags(dqopt, type);
 
-	add_dquot_ref(sb, type);
+	add_dquot_ref(hash, type);
 
 	up(&dqopt->dqoff_sem);
 	return 0;
@@ -1374,9 +1615,9 @@ static void do_get_dqblk(struct dquot *d
 	di->dqb_valid = QIF_ALL;
 }
 
-int vfs_get_dqblk(struct super_block *sb, int type, qid_t id, struct if_dqblk *di)
+int vfs_get_dqblk(struct dqhash *hash, int type, qid_t id, struct if_dqblk *di)
 {
-	struct dquot *dquot = dqget(sb, id, type);
+	struct dquot *dquot = dqget(hash, id, type);
 
 	if (!dquot)
 		return -EINVAL;
@@ -1420,7 +1661,7 @@ static void do_set_dqblk(struct dquot *d
 			dquot->dq_flags &= ~DQ_BLKS;
 		}
 		else if (!(di->dqb_valid & QIF_BTIME))	/* Set grace only if user hasn't provided his own... */
-			dm->dqb_btime = CURRENT_TIME + sb_dqopt(dquot->dq_sb)->info[dquot->dq_type].dqi_bgrace;
+			dm->dqb_btime = CURRENT_TIME + dqh_dqopt(dquot->dq_dqh)->info[dquot->dq_type].dqi_bgrace;
 	}
 	if (check_ilim) {
 		if (!dm->dqb_isoftlimit || dm->dqb_curinodes < dm->dqb_isoftlimit) {
@@ -1428,7 +1669,7 @@ static void do_set_dqblk(struct dquot *d
 			dquot->dq_flags &= ~DQ_INODES;
 		}
 		else if (!(di->dqb_valid & QIF_ITIME))	/* Set grace only if user hasn't provided his own... */
-			dm->dqb_itime = CURRENT_TIME + sb_dqopt(dquot->dq_sb)->info[dquot->dq_type].dqi_igrace;
+			dm->dqb_itime = CURRENT_TIME + dqh_dqopt(dquot->dq_dqh)->info[dquot->dq_type].dqi_igrace;
 	}
 	if (dm->dqb_bhardlimit || dm->dqb_bsoftlimit || dm->dqb_ihardlimit || dm->dqb_isoftlimit)
 		dquot->dq_flags &= ~DQ_FAKE;
@@ -1437,9 +1678,9 @@ static void do_set_dqblk(struct dquot *d
 	dquot->dq_flags |= DQ_MOD;
 }
 
-int vfs_set_dqblk(struct super_block *sb, int type, qid_t id, struct if_dqblk *di)
+int vfs_set_dqblk(struct dqhash *hash, int type, qid_t id, struct if_dqblk *di)
 {
-	struct dquot *dquot = dqget(sb, id, type);
+	struct dquot *dquot = dqget(hash, id, type);
 
 	if (!dquot)
 		return -EINVAL;
@@ -1449,9 +1690,9 @@ int vfs_set_dqblk(struct super_block *sb
 }
 
 /* Generic routine for getting common part of quota file information */
-int vfs_get_dqinfo(struct super_block *sb, int type, struct if_dqinfo *ii)
+int vfs_get_dqinfo(struct dqhash *hash, int type, struct if_dqinfo *ii)
 {
-	struct mem_dqinfo *mi = sb_dqopt(sb)->info + type;
+	struct mem_dqinfo *mi = dqh_dqopt(hash)->info + type;
 
 	ii->dqi_bgrace = mi->dqi_bgrace;
 	ii->dqi_igrace = mi->dqi_igrace;
